var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { BUNDLER_ADDRESS } from "@farcaster/hub-nodejs";
import { EVMContractAddress, FarcasterBundlerContractError, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../../implementations/BaseContract.js";
import { ContractsAbis, } from "../../interfaces/objects/index.js";
let FarcasterBundlerContract = class FarcasterBundlerContract extends BaseContract {
    constructor(providerOrSigner) {
        super(providerOrSigner, EVMContractAddress(BUNDLER_ADDRESS), ContractsAbis.FarcasterBundlerAbi.abi);
        this.providerOrSigner = providerOrSigner;
    }
    price(extraStorage) {
        // https://optimistic.etherscan.io/address/0x00000000fc04c910a0b5fea33b03e0447ad0b0aa#code#F1#L60
        return ResultAsync.fromPromise(this.contract.price(extraStorage), (e) => {
            return this.generateError(e, "Unable to call price()");
        });
    }
    register(registrationParams, signerParams, extraStorage, overrides) {
        return this.assureSigner("register").andThen(() => {
            return this.writeToContract("register", [registrationParams, signerParams, extraStorage], overrides);
        });
    }
    generateContractSpecificError(msg, e, transaction) {
        return new FarcasterBundlerContractError(msg, e, transaction);
    }
};
FarcasterBundlerContract = __decorate([
    injectable(),
    __metadata("design:paramtypes", [Object])
], FarcasterBundlerContract);
export { FarcasterBundlerContract };
//# sourceMappingURL=FarcasterBundlerContract.js.map