var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ID_REGISTRY_ADDRESS } from "@farcaster/hub-nodejs";
import { EVMContractAddress, FarcasterIdRegistryContractError, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ResultAsync, okAsync } from "neverthrow";
import { BaseContract } from "../../implementations/BaseContract.js";
import { ContractsAbis } from "../../interfaces/objects/index.js";
let FarcasterIdRegistryContract = class FarcasterIdRegistryContract extends BaseContract {
    constructor(providerOrSigner) {
        super(providerOrSigner, EVMContractAddress(ID_REGISTRY_ADDRESS), ContractsAbis.FarcasterIdRegistryAbi.abi);
        this.providerOrSigner = providerOrSigner;
    }
    idOf(ownerAddress) {
        return ResultAsync.fromPromise(this.contract.idOf(ownerAddress), (e) => {
            return this.generateError(e, "Unable to call idOf()");
        }).andThen((id) => {
            // If the returned value is 0, then the owner address provided does not have an FID, return null
            if (id == 0) {
                return okAsync(null);
            }
            return okAsync(id);
        });
    }
    generateContractSpecificError(msg, e, transaction) {
        return new FarcasterIdRegistryContractError(msg, e, transaction);
    }
};
FarcasterIdRegistryContract = __decorate([
    injectable(),
    __metadata("design:paramtypes", [Object])
], FarcasterIdRegistryContract);
export { FarcasterIdRegistryContract };
//# sourceMappingURL=FarcasterIdRegistryContract.js.map