import { EVMContractAddress, BigNumberString, BlockchainCommonErrors } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
import { IBaseContract } from "../interfaces/IBaseContract.js";
import { Tag } from "../interfaces/objects";
export interface IContentObjectContract<T> extends IBaseContract {
    tagIndices(tag: string, stakingToken: EVMContractAddress): ResultAsync<BigNumberString, T | BlockchainCommonErrors>;
    getNumberOfStakedTags(stakingToken: EVMContractAddress): ResultAsync<number, T | BlockchainCommonErrors>;
    getTagArray(stakingToken: EVMContractAddress): ResultAsync<Tag[], T | BlockchainCommonErrors>;
    getContentAddress(): ResultAsync<EVMContractAddress, T | BlockchainCommonErrors>;
}
export declare const IContentObjectContractType: unique symbol;
//# sourceMappingURL=IContentObjectContract.d.ts.map